#Random graphical effects
from util import *

import pygame

def fade(image,seconds,pos=[0,0],screen=None,
        fill=[0,0,0],backdrop=None,mode=1,
        handler=None):
    """fades an image from or to black
    image - a pygame surface to fade up
    seconds - time for the fade
    pos - position to place the surface
    screen - only needed if doing the fade on
             an intermediary surface
    fill - color to fade from
    backdrop - image to fade from
    mode - if 1, fade up, if -1, fade down"""
    if not screen:
        screen = pygame.display.get_surface()
    curimg = image.convert()
    c = pygame.time.Clock()
    addper = 255.0/seconds
    alpha = 0
    maxalpha = 255
    if mode<0:
        addper = -addper
        alpha = 255
        maxalpha = 0
    while 1:
        if handler:
            handler.process()
        alpha += addper*c.tick(60)/1000.0
        if fill and not backdrop:
            screen.fill(fill)
        if backdrop and not fill:
            screen.blit(backdrop,[0,0])
        curimg.set_alpha(alpha)
        screen.blit(curimg,pos)
        pygame.display.update()
        if mode>0 and alpha>=maxalpha: break
        if mode<0 and alpha<=maxalpha: break

def scale(img,width=None,height=None):
    """Scale an image with rotozoom according to 
    width and height, but using the rotozoom function"""
    w,h = img.get_size()
    ch=None
    if width:
        ch = float(width)/w
    if height:
        ch = float(height)/h
    return pygame.transform.rotozoom(img,0,ch).convert()
