import random

class Building(object):
    def __init__(self,loc):
        self.peoples = []
        self.sprite = None
        self.loc = loc

class HQ(Building):
    pass
    
class Gate(Building):
    pass

class Ship(Building):
    def __init__(self,loc):
        Building.__init__(self,loc)
        self.current_metal = 0
        self.needed_metal = 10
        self.p = self.current_metal/self.needed_metal
    def add_metal(self,amt):
        self.current_metal += amt
        print self.current_metal
        self.p = self.current_metal/self.needed_metal
        self.sprite.set_progress(self.p)

class Academy(Building):
    def __init__(self,loc):
        Building.__init__(self,loc)
        self.queue = []
    def add_carrier(self):
        self.queue.append('carrier')
    def add_guard(self):
        self.queue.append('guard')
    def add_medic(self):
        self.queue.append('medic')
    def add_explorer(self):
        self.queue.append('explorer')

class Storage(Building):
    def __init__(self,loc):
        Building.__init__(self,loc)
        self.metal_store = 0
        self.fuel_store = 0
        self.food_store = 1
    def getresource(self):
        import random
        r = random.choice(["metal","fuel"])
        if getattr(self,r+"_store") > 0:
            setattr(self,r+"_store",getattr(self,r+"_store")-1)
            return r
        return None

class Farm(Building):
    def __init__(self,loc):
        Building.__init__(self,loc)
        self.fuel_store = 0
        self.food_store = 0
        self.cost = 1
    def update(self):
        if self.fuel_store >= self.cost:
            self.fuel_store -= self.cost
            self.food_store += 1
    def getresource(self):
        if self.food_store:
            self.food_store -= 1
            return "food"

class Builder(Building):
    def __init__(self,loc,building,taskmaster):
        Building.__init__(self,loc)
        self.metal_store = 0
        self.fuel_store = 0
        self.building = building
        self.use_metal = 0
        self.taskmaster = taskmaster
    def _get_metalrate(self):
        if self.fuel_store<1: return 0
        return self.fuel_store/10.0
    metalrate = property(_get_metalrate)
    def update(self,dt):
        if self.building.p>=1.0: return  #Dont build if building finished
        if not self.metalrate: return    #Dont build if builder not running
        if self.metal_store >=5:         #Put metal into 5_metal packet
            self.use_metal = 5
            self.metal_store -= 5
        if not self.use_metal: return    #Only build if we have a packet
        amt = self.metalrate*dt
        if self.use_metal<amt:
            amt = self.use_metal
        self.use_metal -= amt
        self.building.add_metal(amt)

#Add task
#Complete task
#Tasks bring_resource,...
class Task:
    def __init__(self,master,tasktype,args):
        self.master = master
        self.taskype = tasktype
        self.args = args
    def complete(self):
        print "comp"
        self.master.finished(self)
        
class TaskMaster:
    def __init__(self):
        self.waiting = []
        self.running = []
        self.people = []
        self.working = []
    def finished(self,task):
        if task in self.running:
            self.running.remove(task)
        for p in self.working[:]:
            if p.task==task:
                p.task = None
                self.people.append(p)
                self.working.remove(p)
    def update(self):
        if self.waiting and self.people:
            t = random.choice(self.waiting)
            p = random.choice(self.people)
            p.task = t
            self.waiting.remove(t)
            self.people.remove(p)
            self.working.append(p)
            self.running.append(t)
        print "tasks waiting",self.waiting
        print "tasks running",self.running
        print "people waiting",self.people
        print "people working",self.working
    def addtask(self,number,tasktype,*taskargs):
        for i in range(number):
            t = Task(self,tasktype,taskargs)
            self.waiting.append(t)
    
def test_task_master():
    from graphics import Man
    people = [Man('carrier'),Man('carrier'),Man('carrier')]
    tm = TaskMaster()
    tm.people = people
    construct = Building(0)
    storage = Building(0)
    buildings = [construct,storage]
    tm.addtask(5,'bring_resource','metal',construct,storage)
    for i in range(100):
        for i in range(5):
            tm.update()
        for p in tm.working:
            p.task.complete()
if __name__=="__main__":
    test_task_master()
